/****************************************************************
 * See file COPYING included in distribution for license details
 ****************************************************************/
#include "coordmap.h"
#include <string.h>
#include <stdlib.h>

/************  CoordMap_new  ********************/
CoordMap*
CoordMap_new    (const char* column_name, const char* graph_name)
{
   CoordMap *m;
   m = (CoordMap*)malloc(sizeof(CoordMap));
   
   m->column_name = strdup( column_name );
   m->graph_name  = strdup( graph_name );

   return m;
}


/**********  CoordMap_delete  ******************/
void
CoordMap_delete (CoordMap* m)
{
   if ( m ) {
      if ( m->column_name )
         free (m->column_name);
      if ( m->graph_name )
         free (m->graph_name);
      free (m);
   }
}
