#ifndef _VRML_POSTGRES_H_
#define _VRML_POSTGRES_H_

#ifdef __cplusplus
extern "C" {
#endif


#ifdef POSTGRES_INTERFACE

#include <libpq-fe.h>

typedef struct Postgres_Connection_Data_struct {
   PGresult   *cursor;
   PGconn     *conn;
} Postgres_Connection_Data;
#endif

#include "../interface_defs.h"

int         postgres_init       ( DB_Instance_Data *);

void        postgres_close      ( DB_Instance_Data *);

int         postgres_num_fields ( DB_Instance_Data *);
int         postgres_num_tuples ( DB_Instance_Data *);
char*       postgres_field_name ( DB_Instance_Data *, int field_number);
char*       postgres_get_value  ( DB_Instance_Data *, int tuple, int field_number );
int         postgres_is_null    ( DB_Instance_Data *, int tuple, int field_number );


#ifdef __cplusplus
}
#endif


#endif
