#ifndef _VRML_TEXT_H_
#define _VRML_TEXT_H_

#ifdef __cplusplus
extern "C" {
#endif

#include "../interface_defs.h"
#include <stdlib.h>
#include <stdio.h>

// Simple interface to tab-delimited text file.
// Yes, it is very limited and not particularly well
// implemented.  I'm just looking for a sample implementation
// right now.

#define MAX_NUM_FIELDS 10


typedef struct Text_File_Field_Lookup_struct {
   char *name;
} Text_File_Field_Lookup;

typedef struct Text_Field_Tuple_struct {
   char  *value[MAX_NUM_FIELDS];
} Text_Field_Tuple;

typedef struct Text_File_Connection_Data_struct {
   Text_File_Field_Lookup    field_lookup[ MAX_NUM_FIELDS ];
   int                       num_fields;
   Text_Field_Tuple          **tuples;
   int                       num_tuples;
   FILE                      *read_fp;
} Text_File_Connection_Data;

/* Text_Field_Tuple functions */
Text_Field_Tuple*          Text_Field_Tuple_new        ();
void                       Text_Field_Tuple_delete     (Text_Field_Tuple * );
void                       Text_Field_Tuple_add_value  (Text_Field_Tuple *tuple,
                                                        int              field_num,
                                                        const char       *value );

/* Text_File_Connection_Data functions */
Text_File_Connection_Data* Text_File_Connection_Data_new       ();
void                       Text_File_Connection_Data_delete    ( Text_File_Connection_Data *);
void                       Text_File_Connection_Data_add_tuple ( Text_File_Connection_Data *,
                                                                 Text_Field_Tuple *);

/****************************************************
 Access functions
****************************************************/
int         text_file_init       ( DB_Instance_Data *);

void        text_file_close      ( DB_Instance_Data *);

int         text_file_num_fields ( DB_Instance_Data *);
int         text_file_num_tuples ( DB_Instance_Data *);
char*       text_file_field_name ( DB_Instance_Data *, int field_number);
char*       text_file_get_value  ( DB_Instance_Data *, int tuple, int field_number );
int         text_file_is_null    ( DB_Instance_Data *, int tuple, int field_number );


#ifdef __cplusplus
}
#endif
   
#endif

